#include "basicAlgo.h"

// Dijkstra's shortest path algorithm, using BFS

int *shortestDistanceMatrix (Graph g) {
  int i, n = nNodes (g), matrixSize = n * n;;
  NodeId root, current, neighbor;
  EdgeInfo edgeLabel;
  int *distances = (int *) malloc (matrixSize * sizeof(int));

/* initially set all distances to infinity, i.e. the number of nodes */
  for (i = 0; i < matrixSize; i++) 
    distances[i] = n;
  
  for (root = 0; root < n; root++) {
    distances[root*n + root] = 0;
    BFS (g, root, current, neighbor, edgeLabel,
	 // and here's what to do at each node:
           { distances[i*n + neighbor] = distances[i*n + current] + 1; }
	 );
  }
  return distances;
}
