#ifndef IncludedGraphAlgo
#define IncludedGraphAlgo

/* an example of graph library usage */

#include "intset.h"
#include "queue.h"
#include "graph.h"

/* BFS : (Graph, var int, var int, var int, var int, command) -> command
 * -- performs breadth-first-search on g starting at node root
 * -- i is the currently explored node
 * -- j is the new neighbor of i
 * -- e is the value of the edge from i to j
 * -- c is code that is run whenever a not yet seen neighbor shows up
 */
#define BFS(g,root,i,j,e,c) { \
  IntSet __visited = NewEmptySet (nNodes (g)); \
  Queue __q = newQueue (); \
  Enqueue (__q, root); \
  SetAdd (__visited, root); \
  while (!emptyQueue (__q)) { \
    i = (int) dequeue (__q); \
    ScanNeighborsOf ((g), i, j, e, { \
      if (!Member (__visited, j)) { \
	Enqueue (__q, j); \
        SetAdd (__visited, j); \
        c \
      } \
    }); \
  } \
  free (__q); \
  free (__visited); \
}

int *shortestDistanceMatrix (Graph g);

#endif
