#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getbingraph.c"

main (int argc, char **argv) {
  int i, j, mode = 0, arg = 1;
  if (argc < 2)
    fprintf (stderr, "usage: %s [-m] <bin-graph> [<name-list-output>]\n  pair list or adjacency matrix on output\n", argv[0]),
      exit (1);
  struct graphInfo g;
  if (argv[1][0] == '-') {
    mode = argv[1][1] == 'm';
    ++arg;
  }
  getGraph (argv[arg], &g);
  if (mode == 0) {
    for (i = 0; i < g.nNodes; ++i) {
      IntSet s = BitMatrixRow (g.graph, g.nNodes, i);
      for (j = SetFindNext (s, g.nNodes, 0);
	   j < g.nNodes;
	   j = SetFindNext (s, g.nNodes, j+1))
	printf ("%s %s\n", g.names[i], g.names[j]);
    }
  }
  else {
    FILE *f;
    if ((f = fopen (argv[arg+1], "w")) == NULL) perror (argv[2]), exit (1);
    for (i = 0; i < g.nNodes; ++i) {
      IntSet s = BitMatrixRow (g.graph, g.nNodes, i);
      fprintf (f, "%s\n", g.names[i]);
      for (j = 0; j < g.nNodes; ++j)
	printf (Member (s, j) ? "1 " : "0 ");
      printf ("\n");
    }
    fclose (f);
  }
}
