#include "intset.h"
#include "trie.h"
#include "mmapfile.c"

struct graphInfo {
  int nNodes, *fromNameId, *toNameId, listrep;
  char **names;
  Dict nodeDict;
  BitMatrix graph;
  int *offsets, *base;
  FILE *baseFile;
  char *mmBase;
  int mmSize;
};

static int countNodes;

int nextNode (const char *s) {
  return countNodes++;
}

int getGraph (const char *fname, struct graphInfo *result) {
  char *start, *c;
  struct stat st;
  FILE *f = openFile (fname);
  result->mmBase = c = mmapFile (f, &st);
  result->mmSize = st.st_size;
  result->baseFile = f;
  int nNodes = *(int *) c;
  result->nNodes = nNodes;
  c += sizeof (int);
  result->graph = (BitMatrix) c;
  result->listrep = 0;
  c += BitMatrixVolume (nNodes, nNodes) * sizeof (int);
  char **names = (char **) malloc (nNodes * sizeof (char *));
  result->names = names;
  result->nodeDict = NULL;
  int i = 0;
  countNodes = 0;
  do {
    names[i] = c;
    DictAdd (&result->nodeDict, c, nextNode);
    while (*c++);
  } while (++i < nNodes);
  return nNodes;
}
