#ifndef IncludedIntHacks
#define IncludedIntHacks

#define LogIntSz 5
#define BitsInInt (1<<LogIntSz)

inline static int signFill (int i) {
  return i >> (BitsInInt-1);
}

inline static int signFlip (int i, int m) {
  return (i^m)-m;
}

inline static int intAbs (int i) {
  return signFlip (i, signFill (i));
}

inline static int intMin (int i, int j) {
  int d = j-i;
  return i + (d & signFill (d));
}

inline static int intMax (int i, int j) {
  int d = i-j;
  return i - (d & signFill (d));
}
  
#endif
