#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>

FILE *openFile (const char *fname) {
  FILE *f;
  if ((f = fopen (fname, "r+")) == NULL) perror (fname), exit (1);
  return f;
}

char *mmapFile (FILE *f, struct stat *stp) {
  fstat (fileno (f), stp);
  char *c = (char *)
    mmap ((void *) 0, stp->st_size, PROT_READ|PROT_WRITE, MAP_SHARED,
	  fileno (f), 0);
  if (c == MAP_FAILED) perror ("mmap"), exit (1);
#ifdef MADV_SEQUENTIAL
  madvise ((void *) c, stp->st_size, MADV_SEQUENTIAL);
#endif
  return c;
}
