#ifndef IncludedQueue
#define IncludedQueue

#include <stdlib.h>
#include "objlist.h"

typedef struct queue {
  ObjList head, *tail;
} *Queue;

inline static Queue newQueue () {
  Queue q = (Queue) malloc (sizeof (struct queue));
  q->head = NULL;
  q->tail = &q->head;
  return q;
}

inline static int emptyQueue (Queue q) {
  return q->head == NULL;
}

inline static void enqueue (Queue q, object item) {
  ObjList p = newListCell (item);
  p->tail = NULL;
  *(q->tail) = p;
  q->tail = &p->tail;
}

#define Enqueue(q,i) (enqueue (q, (object) i))

inline static object dequeue (Queue q) {
  ObjList p = q->head;
  object item = p->head;
  if ((q->head = p->tail) == NULL) q->tail = &q->head;
  free (p);
  return item;
}

#endif
