#ifndef IncludedTrie
#define IncludedTrie

typedef struct asciiTrie *ASCIITrie;

struct asciiTrie {
  char *prefix;
  ASCIITrie *branch;
  int data;
};

int trieAdd (ASCIITrie *root, const char *s0, int newElement (const char *));

int trieLookup (ASCIITrie t, const char *s);

void traverseTrie (ASCIITrie t, char *sbuf, void processElement (int, char *));

void freeTrie (ASCIITrie t);

char **flattenASCIITrie (ASCIITrie t, int n);

#define TrieLookup(dict,Cur,Shift,Done,r) { \
  ASCIITrie __t = (dict), *__b; \
  for (r = -1; __t != NULL; ) { \
    char *__p; \
    for (__p = __t->prefix; (*__p == (Cur)) && (*__p != '\0'); ++__p) Shift; \
    if (Done) { \
      r = __t->data; \
      break; \
    } \
    if (*__p != '\0' || (__b = __t->branch) == NULL) break; \
    __t = __b[(Cur) - ' ']; \
    Shift; \
  } \
}

#define Dict ASCIITrie
#define DictLookup trieLookup
#define DictLookupUntil TrieLookup
#define DictAdd trieAdd

#endif
